[tool.poetry]
name = "ska-low-cbf"
version = "0.13.0"
description = "Tango devices for SKA Low CBF monitoring and control"
authors = ["Your Name <you@example.com>"]
license = "CSIRO Open Source Software License"

packages = [
    { include = "ska_low_cbf", from = "src" }
]

[tool.poetry.scripts]
ska_low_cbf_controller = 'ska_low_cbf.controller.controller_device:main'
ska_low_cbf_allocator = 'ska_low_cbf.allocator.allocator_device:main'
ska_low_cbf_subarray = 'ska_low_cbf.subarray.subarray_device:main'
ska_low_delay_poly = 'ska_low_cbf.delay_poly.delay_device:main'

[[tool.poetry.source]]
name = "ska-nexus"
url = "https://artefact.skao.int/repository/pypi-internal/simple"
# priority = "primary"  # TODO - uncomment when poetry/container upgraded

[[tool.poetry.source]]
name = "PyPI-public"
url = "https://pypi.org/simple"

# for ska_sdp_realtime_receive_core not yet available from CAR
[[tool.poetry.source]]
name = "core-gitlab"
url = "https://gitlab.com/api/v4/projects/34787134/packages/pypi/simple"

[tool.poetry.dependencies]
python = "^3.10"
# ska-tango-images-pytango-runtime:9.5.0 uses pytango 9.5.0, numpy 1.26.0
pytango = "^9.5.0"
numpy = "^1.26.3"
ska-tango-base = "^1.0"
ska-control-model = "^1.0"
ska-ser-logging = "*"
ska-ser-log-transactions = "*"
debugpy = "^1.5.1"
packaging = ">=21"
backoff = "^2.1.2"
schema = "^0.7.5"
ska-tango-testing = "^0.6.0"
ska-telmodel = "^1.7.0"
ska-sdp-realtime-receive-core = "^6.0.0+dev.c2e3daefa"

[tool.poetry.group.dev.dependencies]
black = "22.3.0"
isort = "5.10.1"
pylint = "^2.8.2"
flake8 = "^3.9.2"
pylint-junit = "0.3.2"
coverage = "^6.1.1"
pytest = "7.1.1"
pytest-bdd = "5.0.0"
pytest-cov = "^3.0.0"
pytest-forked = "^1.3.0"
pytest-json-report = "^1.4.1"
pytest-mock = "3.7.0"
pytest-repeat = "^0.9.1"
pytest-timeout = "^2.0.1"
pytest-xdist = "^2.5.0"
platformdirs = "2.5.1"
spead2 = "3.10.0"
dill = "^0.3.6"

[tool.poetry.group.docs.dependencies]
Sphinx = "^6.2.1"
ska-ser-sphinx-theme = "^0.1.1"
sphinx-rtd-theme = "^1.2.1"
sphinx-autodoc-typehints = "^1.23.0"
#sphinxcontrib-plantuml = "^0.25" # future - UML diagrams
recommonmark = "^0.7.1"
# latest docutils: 0.21.2 but the above sphinx-rtd-theme requires <0.19
# see https://docutils.sourceforge.io/RELEASE-NOTES.html
docutils = "^0.18.1"


[build-system]
requires = ["poetry-core>=1.0.0"]
build-backend = "poetry.core.masonry.api"

[tool.black]
line-length = 79

[tool.isort]
profile = "black"
src_paths = ["src/ska_low_cbf", "tests"]
line_length = 79

[tool.pylint."messages control"]
# W0511 (to-do and fix me) because code is still a prototype
disable = ["R0801", "W0511", "too-many-instance-attributes", "too-few-public-methods"]

[tool.pylint.format]
max-line-length = 79
